#pragma once

#include "CoreMinimal.h"
#include "Components/ActorComponent.h"
#include "EAimingCrosshairState.h"
#include "ELockOnState.h"
#include "ESurvivorLockedOnProgressState.h"
#include "K32KillerPodLockOnProgressComponent.generated.h"

class UK32SurvivorLockedOnTimeComponent;
class ASurvivor;

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class THEK32_API UK32KillerPodLockOnProgressComponent : public UActorComponent
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, ReplicatedUsing=OnRep_CrosshairState, Transient, meta=(AllowPrivateAccess=true))
	EAimingCrosshairState _crosshairState;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, ReplicatedUsing=OnRep_Progress, Transient, meta=(AllowPrivateAccess=true))
	float _progress;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Transient, Export, meta=(AllowPrivateAccess=true))
	UK32SurvivorLockedOnTimeComponent* _currentSurvivorLockedOnTimeComponent;

private:
	UFUNCTION(BlueprintCallable, Server, Reliable)
	void Server_SetLockOnState(const ELockOnState state, const EAimingCrosshairState crosshairState, const ASurvivor* survivorBeingLockedOn, const ESurvivorLockedOnProgressState survivorLockedOnProgressState);

	UFUNCTION(BlueprintCallable, Server, Reliable)
	void Server_SetCrosshairState(const EAimingCrosshairState crosshairState);

	UFUNCTION(BlueprintCallable)
	void OnRep_Progress() const;

	UFUNCTION(BlueprintCallable)
	void OnRep_CrosshairState() const;

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	UK32KillerPodLockOnProgressComponent();
};

FORCEINLINE uint32 GetTypeHash(const UK32KillerPodLockOnProgressComponent) { return 0; }
